package ch03_strings;

import java.util.Scanner;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class ScannerExample
{
    public static void main(String[] args)
    {
        try (final Scanner scanner = new Scanner("Version-2.17_45"))
        {
            scanner.useDelimiter("\\.|_|-");
            while (scanner.hasNext())
            {
                System.out.print(scanner.next() + " ");
            }
        }
        System.out.println("\n-----------------");

        try (final Scanner scanner = new Scanner("Version:2:17.45\nLine2"))
        {
            scanner.useDelimiter(":|_|-|\\n");

            var text = scanner.next();
            var intValue = scanner.nextInt();
            var floatValue = scanner.nextFloat();
            var remaining = scanner.next();

            System.out.print(text + " / " + intValue + " / " +
                            floatValue + " / " + remaining);
        }

        System.out.println("\n-----------------");
        try (final Scanner scanner = new Scanner("Line1,Info\nLine2.Special\nLine3:Additonal"))
        {
            var line1 = scanner.nextLine();
            var line2 = scanner.nextLine();
            var line3 = scanner.nextLine();

            System.out.print(line1 + " / " + line2 + " / " + line3);
        }
    }
}
