package ch03_strings.praxisexamples;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class TitleCaseExample
{
    public static void main(String[] args)
    {
        System.out.println(toTitleCase("this is a title"));
        System.out.println(toTitleCase("welcome to einfach java book")); 
        
        System.out.println(toTitleCaseV2("das ist die kürzere variante"));
    }

    static String toTitleCase(String input)
    {
        char[] inputChars = input.toCharArray();

        boolean capitalizeNextChar = true;
        for (int i = 0; i < inputChars.length; i++)
        {
            char currentChar = inputChars[i];

            if (capitalizeNextChar)
            {
                inputChars[i] = Character.toUpperCase(currentChar);
                capitalizeNextChar = false;
            }
            if (Character.isWhitespace(currentChar) || currentChar == '-')
            {
                capitalizeNextChar = true;
            }
        }
        return new String(inputChars);
    }
    
    static boolean shouldCapitalize(char currentChar) 
    { 
        return Character.isWhitespace(currentChar) || currentChar == '-';
    }
    
    static String toTitleCaseV2(String input) 
    {
        char[] inputChars = input.toCharArray();
        
        boolean capitalizeNextChar = true;
        for (int i = 0; i < inputChars.length; i++)
        {
            char currentChar = inputChars[i];
            
            if (capitalizeNextChar)
            {
                inputChars[i] = Character.toUpperCase(currentChar);
            }   
                            
            capitalizeNextChar = shouldCapitalize(currentChar);
        }
        return new String(inputChars);
    }
}
