package ch03_strings.solutions;

import java.util.LinkedList;
import java.util.List;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class Ex05_StringMerge
{
    static String stringMerge(String input1, String input2)
    {
        int length1 = input1.length();
        int length2 = input2.length();
        
        int max_len = Math.max(length1, length2);
        
        String result = "";
        for (int i = 0; i < max_len; i++)
        {
            if (i < length1)
                result += input1.substring(i, i + 1);
            if (i < length2)
                result += input2.substring(i, i + 1);
        }
        return result;
    }
    
    // VERBESSERUNG JAVA CHALLENGE / PYTHON CHALLENGE
    // Array-Merge
    
    static char[] merge(char[] input1, char[] input2)
    {
        int length1 = input1.length;
        int length2 = input2.length;
        
        int max_len = Math.max(length1, length2);
        
        char[] result = new char[length1 + length2];
        int resultPos = 0;
        for (int i = 0; i < max_len; i++)
        {
            if (i < length1)
            {
                result[resultPos] = input1[i];
                resultPos++;
            }
            if (i < length2)
            {
                result[resultPos] = input2[i];
                resultPos++;
            }                               
        }
        return result;
    }
    
    // List-Merge
    static <T> List<T> merge(List<T> input1, List<T> input2)
    {
        int length1 = input1.size();
        int length2 = input2.size();
        
        int max_len = Math.max(length1, length2);
        
        List<T> result = new LinkedList<>();
        for (int i = 0; i < max_len; i++)
        {
            if (i < length1)
                result.add(input1.get(i));
            if (i < length2)
                result.add(input2.get(i));
        }
        return result;
    }
    
    public static void main(String[] args)
    {       
        System.out.println(stringMerge("", "Not Empty"));
        
        char[] first = "First Try".toCharArray();
        char[] second = "Sexond Attempt".toCharArray();

        char[] result = merge(first, second);
        System.out.println(new String(result));
                       
        var list1 = List.of("A", "C", "E");
        var list2 = List.of("B", "D", "F", "G", "H", "I");
        System.out.println(merge(list1, list2));
       
    }
}
