package ch04_arrays;

import java.util.Arrays;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class RotationExample
{
    public static void main(String[] args)
    {
        int[][] values = { { 1, 1, 1, 1 }, 
                           { 2, 2, 2, 2 }, 
                           { 3, 3, 3, 3 }, 
                           { 4, 4, 4, 4, } };

        printArrayJdk(values);
        var result = rotate(values, RotationDirection.LEFT_90);
        printArrayJdk(result);
        printArrayJdk(rotate(values, RotationDirection.LEFT_90));
    }

    private static void printArrayJdk(final int[][] values)
    {
        for (int i = 0; i < values.length; i++)
        {
            System.out.println(Arrays.toString(values[i]));
        }
    }

    enum RotationDirection {
        LEFT_90, RIGHT_90
    }

    public static int[][] rotate(int[][] values, RotationDirection dir)
    {
        int maxX = values[0].length - 1;
        int maxY = values.length - 1;

        final int[][] rotatedArray = new int[maxX + 1][maxY + 1];

        for (int y = 0; y < maxY + 1; y++)
        {
            for (int x = 0; x < maxX + 1; x++)
            {
                int origValue = values[y][x];

                if (dir == RotationDirection.LEFT_90)
                {
                    rotatedArray[maxX - x][y] = origValue;
                }
                if (dir == RotationDirection.RIGHT_90)
                {
                    rotatedArray[x][maxY - y] = origValue;
                }
            }
        }

        return rotatedArray;
    }

    public static int[][] rotateNicer(int[][] values, RotationDirection dir)
    {
        int origLengthX = values[0].length;
        int origLengthY = values.length;

        final int[][] rotatedArray = new int[origLengthX][origLengthY];

        for (int y = 0; y < values.length; y++)
        {
            for (int x = 0; x < values[0].length; x++)
            {
                int maxX = values[0].length - 1;
                int maxY = values.length - 1;

                int origValue = values[y][x];

                if (dir == RotationDirection.LEFT_90)
                {
                    rotateLeft(rotatedArray, y, x, maxX, origValue);
                }
                if (dir == RotationDirection.RIGHT_90)
                {
                    roteteRight(rotatedArray, y, x, maxY, origValue);
                }
            }
        }

        return rotatedArray;
    }

    private static void rotateLeft(final int[][] rotatedArray, int y, int x, int maxX, int origValue)
    {
        int newX = y;
        int newY = maxX - x;

        rotatedArray[newY][newX] = origValue;
    }

    private static void roteteRight(final int[][] rotatedArray, int y, int x, int maxY, int origValue)
    {
        int newX = maxY - y;
        int newY = x;

        rotatedArray[newY][newX] = origValue;
    }
}
