package ch04_arrays;

import java.util.Arrays;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class SwapAndReverseExample
{
    public static void main(String[] args)
    {
        int[] numbers = { 1,2,3,4,5,6,7,8,9 };
        
        swap(numbers, 3, 5);
        swap(numbers, 2, 6);
        System.out.println(Arrays.toString(numbers));

        swap(numbers, 1, 7);
        swap(numbers, 0, 8);
        System.out.println(Arrays.toString(numbers));

        // reverse 1
        reverse(numbers, 0, numbers.length - 1);
        System.out.println(Arrays.toString(numbers));
        
        // reverse 2
        reverse2(numbers, 0, numbers.length - 1);
        System.out.println(Arrays.toString(numbers));
        
        // reverse rekursiv
        reverseRec(numbers, 0, numbers.length - 1);
        System.out.println(Arrays.toString(numbers));
    }

    public static void reverse(final int[] values, int start, int end)
    {
        while (start < end)
        {
            swap(values, start, end);
            
            start++;
            end--;
        }
    }
    
    public static void reverse2(final int[] values, int start, int end)
    {
        for (int i = start; i < end / 2; i++)
        {
            swap(values, i, end - i);
        }
    }
    
    public static void reverseRec(final int[] values, int start, int end)
    {
        if (start < end)
        {
            swap(values, start, end);
            
            reverseRec(values, start + 1, end - 1);
        }
    }
    
    public static void swap(final int[] values, final int first, final int second)
    {
        final int tmp = values[first];

        values[first] = values[second];
        values[second] = tmp;
    }
}
