package ch04_arrays.praxsiexamples;

import java.util.Arrays;
import java.util.List;

import ch04_arrays.Direction;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class FloodFillExample
{
    public static void main(String[] args)
    {
        char[][] world = firstWorld();
        floodFillV2(world, 1, 1);

        printArrayJdk(world);
    }

    private static char[][] firstWorld()
    {
        return new char[][] { "   #  ".toCharArray(),
                              "    # ".toCharArray(),
                              "#   # ".toCharArray(),
                              " # #  ".toCharArray(),
                              "  #   ".toCharArray()};
    }
    
    private static void printArrayJdk(final char[][] values)
    {
        for (int i = 0; i < values.length; i++)
        {
            System.out.println(Arrays.toString(values[i]));
        }
    }
    
    static void floodFill(final char[][] values, final int x, final int y) 
    {          
        // $\mbox{\bfseries rekursiver Abbruch}$
        if (x < 0 || y < 0 || y >= values.length || x >= values[y].length)
            return;
                                            
        if (values[y][x] == ' ')
        {
            values[y][x] = '*';
            
            // $\mbox{\bfseries rekursiver Abstieg: fülle in alle 4 Richtungen}$
            floodFill(values, x, y-1);
            floodFill(values, x+1, y);
            floodFill(values, x, y+1);
            floodFill(values, x-1, y);
        }
    }
    
    static boolean isOnBoard(final char[][] values, 
                             final int posX, final int posY)
    {
        return posX >= 0 && posY >= 0 && 
               posX < values[0].length && posY < values.length;
    }
    
    static void floodFillV2(final char[][] values, final int x, final int y) 
    {        
        // $\mbox{\bfseries rekursiver Abbruch}$
        if (!isOnBoard(values, x, y))
            return;
                                    
        if (values[y][x] == ' ')
        {
            values[y][x] = '*';
            
            // $\mbox{\bfseries rekursiver Abstieg in 4 Richtungen}$
            for (final Direction dir : List.of(Direction.N, Direction.E, Direction.S, Direction.W))
            {
                floodFillV2(values, x + dir.dx, y + dir.dy);
            }            
        }
    }
}
