package ch05_oo_design.carapp;

import java.util.Objects;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
class Car4
{
    String make;

    String color;

    int    ps;

    Car4()
    {
        this("Unbekannt", "Unlackiert", 0);
    }

    Car4(String make, String color, int ps)
    {
        this.make = make;
        this.color = color;
        this.ps = ps;
    }

    public void paintWith(String newColor) {
        this.color = newColor;
    }
    
    public void applyTuningKit()
    {
        this.ps += 150;
    }
    
    @Override
    public String toString()
    {
        return "Marke: " + make + " / Farbe: " + color + " / PS: " + ps;
    }

    @Override
    public int hashCode()
    {
        return Objects.hash(color, make, ps);
    }

    @Override
    public boolean equals(Object obj)
    {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        
        Car4 other = (Car4) obj;
        return Objects.equals(color, other.color) && 
               Objects.equals(make, other.make) && ps == other.ps;
    }   
}