package ch05_oo_design.carapp;

import java.util.Objects;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class CarManagementApplication
{
    Car[] availableCars = new Car[] {  new Car("Renault", CarColor.BLUE, 75),
                                       new Car("Renault", CarColor.PETROL, 175),
                                       new Car("Ferrari", CarColor.RED, 455),
                                       new Car("BMW", CarColor.GREEN, 255),
                                       new Car("BMW", CarColor.YELLOW, 125),
                                       new Car("VW", CarColor.WHITE, 65),
                                       new Car("VW", CarColor.BLUE, 105) };

    private CarManagementApplication()
    {        
    }
    
    private void showByMake(String make)
    {
        for (int i = 0; i < availableCars.length; i++)
        {
            if (availableCars[i].make.equals(make))
                System.out.println(availableCars[i]);
        }       
    }
    
    private void filterByPS(int minPS)
    {
        for (int i = 0; i < availableCars.length; i++)
        {
            if (availableCars[i].ps > minPS)
                System.out.println(availableCars[i]);
        }       
    }
    
    private void filterByColor(String color)
    {
        for (int i = 0; i < availableCars.length; i++)
        {
            if (availableCars[i].color.equals(color))
                System.out.println(availableCars[i]);
        }       
    }
    
    
    public static void main(String[] args)
    {
        CarManagementApplication app = new CarManagementApplication();

        System.out.println("Alle Renaults im Angebot:");
        app.showByMake("Renault");

        System.out.println();
        
        System.out.println("Alle Autos mit mehr als 150 PS:");
        app.filterByPS(150);
    }

        
    
        



enum CarColor
{
    NONE, RED, BLUE, GREEN, WHITE, YELLOW, PETROL;
}


static class Car
{
    String make;

    private CarColor color;

    public String getMake()
    {
        return make;
    }

    public int getPs()
    {
        return ps;
    }

    public void setPs(int ps)
    {
        this.ps = ps;
    }

    int    ps;

    Car()
    {
        this.make = "Unbekannt";
        this.color = CarColor.NONE;
        this.ps = 0;
    }

    Car(String make, CarColor color, int ps)
    {
        this.make = make;
        this.color = color;
        this.ps = ps;
    }

    public void paintWith(CarColor newColor) 
    {
        this.color = newColor;
    }
    
    public void applyTuningKit()
    {
        this.ps += 150;
    }
    
    @Override
    public String toString()
    {
        return "Marke: " + make + " / Farbe: " + color + " / PS: " + ps;
    }

    @Override
    public int hashCode()
    {
        return Objects.hash(color, make, ps);
    }

    @Override
    public boolean equals(Object obj)
    {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        
        Car other = (Car) obj;
        return Objects.equals(color, other.color) && 
               Objects.equals(make, other.make) && ps == other.ps;
    }    
}
}
