package ch05_oo_design.carapp.domain;

import java.util.Objects;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class Car
{
    private String brand;

    private CarColor color;

    private int    horsePower;

    public Car()
    {
        this("Unbekannt", CarColor.NONE, 0);
    }

    public Car(String brand, CarColor color, int horsePower)
    {
        this.brand = brand;
        this.color = color;
        this.horsePower = horsePower;
    }
    
    public void applyTuningKit()
    {
        this.setHorsePower(this.getHorsePower() + 150);
    }
        
    public void paintWith(CarColor newColor) 
    {
        this.color = newColor;
    }

    public String getBrand()
    {
        return brand;
    }

    public CarColor getColor()
    {
        return color;
    }

    public void setColor(CarColor color)
    {
        this.color = color;
    } 
    
    public int getHorsePower()
    {
        return horsePower;
    }
    
    public void setHorsePower(int horsePower)
    {
        if (horsePower <= 0 || horsePower > 2_000)
            throw new IllegalArgumentException("INVALID PS: must be im range 1 -- 2000");
        
        this.horsePower = horsePower;
    }
   
    @Override
    public String toString()
    {
        return "Marke: " + getBrand() + " / Farbe: " + getColor() + " / PS: " + getBrand();
    }

    @Override
    public boolean equals(Object obj)
    {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        
        Car other = (Car) obj;
        return Objects.equals(getColor(), other.getColor()) && 
               Objects.equals(getBrand(), other.getBrand()) && getBrand() == other.getBrand();
    }

}