package ch05_oo_design.carapp.domain;

import java.util.Objects;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class CarOrig
{
    private String brand;

    String color;

    private int    horsePower;

    public CarOrig()
    {
        this("Unbekannt", "Unlackiert", 0);
    }

    public CarOrig(String brand, String color, int horsePower)
    {
        this.setBrand(brand);
        this.color = color;
        this.setHorsePower(horsePower);
    }

    public void paintWith(String newColor) 
    {
        this.color = newColor;
    }
    
    public void applyTuningKit()
    {
        this.setHorsePower(this.getHorsePower() + 150);
    }
    
    @Override
    public String toString()
    {
        return "Marke: " + getBrand() + " / Farbe: " + color + " / PS: " + getBrand();
    }

    @Override
    public boolean equals(Object obj)
    {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        
        CarOrig other = (CarOrig) obj;
        return Objects.equals(color, other.color) && 
               Objects.equals(getBrand(), other.getBrand()) && getBrand() == other.getBrand();
    }

    public String getBrand()
    {
        return brand;
    }
    
    public void setBrand(String brand)
    {
        this.brand = brand;
    }
    
    public int getHorsePower()
    {
        return horsePower;
    }
    
    public void setHorsePower(int horsePower)
    {
        if (horsePower <= 0 || horsePower > 2_000)
            throw new IllegalArgumentException("INVALID PS: must be im range 1 -- 2000");
        
        this.horsePower = horsePower;
    }    
}