package ch05_oo_design.carapp.main;

import ch05_oo_design.carapp.domain.Car;
import ch05_oo_design.carapp.domain.CarColor;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class CarManagementApplication
{
    Car[] availableCars = new Car[] {  new Car("Renault", CarColor.BLUE, 75),
            new Car("Renault", CarColor.PETROL, 175),
            new Car("Ferrari", CarColor.RED, 455),
            new Car("BMW", CarColor.GREEN, 255),
            new Car("BMW", CarColor.YELLOW, 125),
            new Car("VW", CarColor.WHITE, 65),
            new Car("VW", CarColor.BLUE, 105) };


    private CarManagementApplication()
    {        
    }

    private void filterByBrand(String brand)
    {
        for (Car currentCar : availableCars)
        {
            if (currentCar.getBrand().equals(brand))
                System.out.println(currentCar);
        }       
    }
    
    private void filterByHorsePowerGreaterThan(int minHorsePower)
    {
        for (int i = 0; i < availableCars.length; i++)
        {
            if (availableCars[i].getHorsePower() > minHorsePower)
                System.out.println(availableCars[i]);
        }       
    }
    
    public static void main(String[] args)
    {
        CarManagementApplication app = new CarManagementApplication();

        System.out.println("Alle Renaults im Angebot:");
        app.filterByBrand("Renault");

        System.out.println();
        
        System.out.println("Alle Autos mit mehr als 150 PS:");
        app.filterByHorsePowerGreaterThan(150);
    }
}
