package ch05_oo_design.carapp.main;

import ch05_oo_design.carapp.domain.CarOrig;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class CarManagementApplicationOrig
{
    CarOrig[] availableCars = new CarOrig[] {  new CarOrig("Renault", "BLUE", 75),
                                       new CarOrig("Renault", "PETROL", 175),
                                       new CarOrig("Ferrari", "RED", 455),
                                       new CarOrig("BMW", "GREEN", 255),
                                       new CarOrig("BMW", "YELLOW", 125),
                                       new CarOrig("VW", "WHITE", 65),
                                       new CarOrig("VW", "BLUE", 105) };

    private CarManagementApplicationOrig()
    {        
    }
    
    private void filterByBrand(String brand)
    {
        for (CarOrig currentCar : availableCars)
        {
            if (currentCar.getBrand().equals(brand))
                System.out.println(currentCar);
        }       
    }
    
    private void filterByHorsePowerGreaterThan(int minHorsePower)
    {
        for (int i = 0; i < availableCars.length; i++)
        {
            if (availableCars[i].getHorsePower() > minHorsePower)
                System.out.println(availableCars[i]);
        }       
    }
    
    public static void main(String[] args)
    {
        CarManagementApplicationOrig app = new CarManagementApplicationOrig();

        System.out.println("Alle Renaults im Angebot:");
        app.filterByBrand("Renault");

        System.out.println();
        
        System.out.println("Alle Autos mit mehr als 150 PS:");
        app.filterByHorsePowerGreaterThan(150);
    }
}
