package ch05_oo_design.solutions;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2020 Michael Inden
 */
public class CounterWithOverflow extends Counter
{
    private static final int COUNTER_MAX   = 100;

    private int              overflowCount = 0;

    public int getOverflowCount()
    {
        return overflowCount;
    }

    @Override
    public void reset()
    {
        super.reset();
        overflowCount = 0;
    }

    @Override
    public void increment()
    {
        if (getValue() == COUNTER_MAX - 1)
        {
            super.reset();
            overflowCount++;
        }
        else
        {
            super.increment();
        }
    }
}