package ch05_oo_design.solutions;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2020 Michael Inden
 */
public class CounterWithOverflow2 extends Counter
{
    private static final int COUNTER_MAX   = 100;

    private final Counter    overflowCount = new Counter();

    public int getOverflowCount()
    {
        return overflowCount.getValue();
    }

    @Override
    public void reset()
    {
        super.reset();
        overflowCount.reset();
    }

    @Override
    public void increment()
    {
        if (getValue() == COUNTER_MAX - 1)
        {
            super.reset();
            overflowCount.increment();
        }
        else
        {
            super.increment();
        }
    }
}