package ch05_oo_design.solutions;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2020 Michael Inden
 */
public class SuperHero
{
    private final String name;

    private final String superPower;

    private int          strength;

    public SuperHero(String name, String superPower, int strength)
    {
        this.name = name;
        this.superPower = superPower;
        this.strength = strength;
    }

    private String getName()
    {
        return name;
    }
    
    public String getSuperPower()
    {
        return superPower;
    }

    public int getStrength()
    {
        return strength;
    }

    public void setStrength(int newStrength)
    {
        this.strength = newStrength;
    }
    
    @Override
    public String toString()
    {
        return name + " has " + superPower + " and strength: " + strength;
    }
    
    public boolean isStrongerThan(SuperHero other)
    {
        return strength > other.strength;
    }
    
    public static SuperHero strongestOf(SuperHero... heros)
    {
        SuperHero strongestHero = null;
        for (SuperHero hero : heros)
        {
            if (strongestHero == null || 
                hero.isStrongerThan(strongestHero))
            {
                strongestHero = hero;
            }
        }
            
        return strongestHero;
    }
    
    public static void main(String[] args)
    {
        SuperHero superMan = new SuperHero("Superman", "Kryptonite-Power", 1_000);
        SuperHero batMan = new SuperHero("Batman", "Techno-Power", 100);
        SuperHero ironMan = new SuperHero("Ironman", "Techno-Power", 500);
    
        System.out.println("Superman stronger than Batman? " + 
                           superMan.isStrongerThan(batMan));
        System.out.println(SuperHero.strongestOf(superMan, batMan, ironMan));
    }
}
