package ch06_collections;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class ListsIntro
{
    public static void main(String[] args)
    {
        var names = new ArrayList<String>();

        var unmodifiableNames = List.of("Jim", "James");

        names.add("Tim");
        names.add("Tom");
        System.out.println(names);

        names.addAll(List.of("Maike", "Peter", "John"));
        System.out.println(names);

        names.add(0, "Anton");
        names.add(1, "Andreas");
        System.out.println(names);

        names.add(7, "Last");
        System.out.println(names);

        System.out.println("contains(John)? " + names.contains("John"));
        System.out.println("contains(Michael)? " + names.contains("Michael"));

        System.out.println("get(4)? " + names.get(4));

        names.set(4, "Mike");
        System.out.println(names);

        names.remove(4);
        System.out.println(names);

        names.removeIf(name -> name.startsWith("T") || name.startsWith("A"));
        System.out.println(names);

        System.out.println("size()? " + names.size());

        for (int i = 0; i < names.size(); i++)
            System.out.println(names.get(i));

        for (String name : names)
            System.out.println(name);

        // 

        var primeNumbers = new ArrayList<>(List.of(2, 3, 5, 7, 11, 13, 17, 19));
        
        var numbersToBeSorted = new ArrayList<>(List.of(1,7,2,9,11,6,3));
        Collections.sort(numbersToBeSorted);
        System.out.println(numbersToBeSorted);
        
        
        // 
        
        var femaleNames = List.of("Anne", "Barbara", "Janne", "Lili", "Sophie");
        System.out.println(femaleNames.subList(3,  5));
        		
    }
}
