package ch06_collections;

import java.util.HashMap;
import java.util.Map;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class MapIntro
{
    public static void main(String[] args)
    {
        var<String, Integer> cityInhabitantsMap = new HashMap<String, Integer>();
        
        var<String, Integer> unmodifiableMap = Map.of("Bern", 170_000, "Berlin", 3_500_000);

        cityInhabitantsMap.put("Zürich", 400_000);
        cityInhabitantsMap.put("Hamburg", 2_000_000);
        cityInhabitantsMap.put("Kiel", 250_000);
        System.out.println(cityInhabitantsMap);

        cityInhabitantsMap.putAll(unmodifiableMap);
        System.out.println(cityInhabitantsMap);

        System.out.println("containsKey(Zürich)? " + cityInhabitantsMap.containsKey("Zürich"));
        System.out.println("containsKey(Bremen)? " + cityInhabitantsMap.containsKey("Bremen"));

        System.out.println("containsValue(400000)? " + cityInhabitantsMap.containsValue(400000));
        System.out.println("containsValue(1234567)? " + cityInhabitantsMap.containsValue(1234567));

        System.out.println("get(Zürich)? " + cityInhabitantsMap.get("Zürich"));
        System.out.println("get(X-STADT)? " + cityInhabitantsMap.get("X-STADT"));
        System.out.println("getOrDefault(X-STADT, 0)? " + cityInhabitantsMap.getOrDefault("getOrDefault", 0));

        cityInhabitantsMap.remove("Bern");
        cityInhabitantsMap.remove("Kiel");
        System.out.println(cityInhabitantsMap);

        System.out.println("size()? " + cityInhabitantsMap.size());

        //
        
        for (String city : cityInhabitantsMap.keySet()) {
             System.out.println(city);
        }
        for (int inhabitantCount : cityInhabitantsMap.values()) {
             System.out.println(inhabitantCount);
        }
        for (Map.Entry entry : cityInhabitantsMap.entrySet()) {
             System.out.println(entry);
        }
            
        // 
        
        cityInhabitantsMap.values().removeIf(n -> n > 1_000_000);      
        System.out.println("removeIf(): " + cityInhabitantsMap);       		
    }
}
