package ch06_collections;

import java.time.LocalDate;
import java.util.ArrayList;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class NewStyleList
{
    record Person(String name, LocalDate birthday, String city) {}
    
    public static void main(final String[] args)
    {
        // Typsichere Definition mit Generics
        final ArrayList<Person> personList = new ArrayList<>();
        personList.add(new Person("Max", LocalDate.now(), "Musterstadt"));
        personList.add(new Person("Moritz", LocalDate.now(), "Musterstadt")); 
        //personList.add("Sarah vom Auetal”); // Compile-Error
        
        for (int i = 0; i < personList.size(); i++)
        {
            // Typsicheres Auslesen
            final Person person = personList.get(i);
            System.out.println(person.name() + " aus " + person.city());
        }
    }
}
