package ch06_collections;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

import ch06_collections.NewStyleList.Person;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public final class Pair<T1, T2>
{
    private final T1 first;

    private final T2 second;

    public Pair(final T1 first, final T2 second)
    {
        this.first = first;
        this.second = second;
    }

    public final T1 getFirst()
    {
        return first;
    }

    public final T2 getSecond()
    {
        return second;
    }

    public static void main(String[] args)
    {
        final Person wizard = new Person("Wizard", LocalDate.of(1970, 7, 17), "Kiel");
        final Person mike = new Person("Mike", LocalDate.of(1971, 2, 7), "Bremen");
        
        final Pair<String, Person> pair1 = new Pair<>("DarkLord", wizard);
        final Pair<String, Person> pair2 = new Pair<>("Iron", mike);
        
        // Liste aus Paaren
        List<Pair<String, Person>> pairs = new ArrayList<>();
        pairs.add(pair1);
        pairs.add(pair2);
        
        // Neues Paar für eine Suche definieren
        final Pair<String, Person> pairToSearch = new Pair<>("Iron", mike);
        System.out.println("index: " + pairs.indexOf(pairToSearch));
        System.out.println("found? " + pairs.contains(pairToSearch));
    }
}
