package ch06_collections;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

import ch06_collections.NewStyleList.Person;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public final record Pair2<T1, T2>(T1 first, T2 second)
{
    public static void main(String[] args)
    {
        final Person wizard = new Person("Wizard", LocalDate.of(1970, 7, 17), "Kiel");
        final Person mike = new Person("Mike", LocalDate.of(1971, 2, 7), "Bremen");
        
        final Pair2<String, Person> pair1 = new Pair2<>("DarkLord", wizard);
        final Pair2<String, Person> pair2 = new Pair2<>("Iron", mike);
        
        // Liste aus Paaren
        List<Pair2<String, Person>> pairs = new ArrayList<>();
        pairs.add(pair1);
        pairs.add(pair2);
        
        // Neues Paar für eine Suche definieren
        final Pair2<String, Person> pairToSearch = new Pair2<>("Iron", mike);
        System.out.println("index: " + pairs.indexOf(pairToSearch));
        System.out.println("found? " + pairs.contains(pairToSearch));
    }
}
