package ch06_collections;

import java.util.HashSet;
import java.util.Set;
import java.util.TreeSet;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class SetIntro
{
    public static void main(String[] args)
    {
        var names = new HashSet<String>();

        var unmodifiableNames = Set.of("Jim", "James");

        names.add("Tim");
        names.add("Tom");
        names.add("Tim");
        System.out.println(names);

        names.addAll(Set.of("Mike", "Peter", "John"));
        names.addAll(Set.of("Mike", "Peter", "John"));
        System.out.println(names);

        System.out.println("contains(John)? " + names.contains("John"));
        System.out.println("contains(Michael)? " + names.contains("Michael"));

        names.remove("John");
        System.out.println(names);
        
        names.removeIf(name -> name.startsWith("T"));
        System.out.println(names);

        System.out.println("size()? " + names.size());

        for (String name : names)
            System.out.println(name);

        // 

        var hobbies = Set.of("Musik", "Wandern", "Hifi", "Programmieren",
                             "Kochen", "Heimkino", "Lesen", "Chillen");
        
        System.out.println(new TreeSet<>(hobbies));    	
    }
}
