package ch06_collections.praxisexamples;

import java.util.ArrayList;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class MyStack<E> implements IStack<E>
{
    private final ArrayList<E> values = new ArrayList<>();

    @Override
    public void push(final E elem)
    {
        values.add(elem);
    }

    @Override
    public E pop()
    {
        return values.remove(values.size() - 1);
    }

    @Override
    public E peek()
    {
        return values.get(values.size() - 1);
    }

    @Override
    public boolean isEmpty()
    {
        return values.isEmpty();
    }

    public static void main(String[] args)
    {
        IStack<String> stack = new MyStack<>();
        stack.push("first");
        stack.push("second");

        System.out.println("PEEK: " + stack.peek());
        System.out.println("POP: " + stack.pop());
        System.out.println("POP: " + stack.pop());
        System.out.println("ISEMPTY: " + stack.isEmpty());
        System.out.println("POP: " + stack.pop());
    }
}