package ch06_collections.solutions;

import java.util.HashMap;
import java.util.List;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class Ex06_NameCount
{
    public static void main(String[] args)
    {
        var names = List.of("Tim", "Tom", "Mike", "Jim", "Tim", "Mike", "James", "Mike");

        var nameToCountMap = new HashMap<String, Integer>();

        for (String name : names)
        {
            if (nameToCountMap.containsKey(name))
            {
                int currentCount = nameToCountMap.get(name);
                nameToCountMap.put(name, currentCount + 1);
            }
            else
            {
                nameToCountMap.put(name, 1);
            }
        }

        System.out.println(nameToCountMap);

        // Variante
        for (String name : names)
        {
            nameToCountMap.computeIfPresent(name, (key, value) -> value++);
            nameToCountMap.putIfAbsent(name, 1);
        }
        System.out.println(nameToCountMap);
    }
}
