package ch06_collections.solutions;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Stack;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class Ex08_ListReverse
{
    public static void main(String[] args)
    {
        final List<String> values = List.of("A", "BB", "CCC", "DDDD");
        
        System.out.println(reverse(values));
        System.out.println(listReverseWithStack(values));
    }

    static <T> List<T> reverse(final List<T> values) 
    {       
        final List<T> result = new ArrayList<>();
        
        for (int i = values.size() - 1; i >= 0; i--)
        {
            result.add(values.get(i));
        }
        return result;
    }
    
    static <T> List<T> listReverseWithStack(final List<T> inputs) 
    {       
        // $\mbox{\bfseries Idee: Durchlaufe die Liste von vorne nach hinten (performant) und }$
        // $\mbox{\bfseries befülle einen Stack}$
        final Stack<T> allValues = new Stack<>();
        final Iterator<T> it = inputs.iterator();
        while (it.hasNext())
        {
            allValues.push(it.next());
        }
        
        // $\mbox{\bfseries Leere den Stack und befülle eine Ergebnisliste}$
        final List<T> result = new ArrayList<>();
        while (!allValues.isEmpty())
        {
            result.add(allValues.pop());
        }
        
        return result;
    }
}
