package ch07_misc.solutions;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class Ex03_TempConverter
{
    enum TempConv {
        F2C, C2F 
    }

    public static void main(String[] args)
    {
        System.out.println(convertMoreReadable(TempConv.C2F, 35));
        System.out.println(convertMoreReadable(TempConv.F2C, 95));
    }

    static double fahrenheitToCelsius(int tempFH)
    {
        return (tempFH - 32) / 1.8;
    }

    static double celsiusToFahrenheit(int tempCS)
    {
        return tempCS * 1.8 + 32;
    }

    static double convertMoreReadable(TempConv convert, int temperature)
    {
        return switch (convert)
        {
            case C2F -> celsiusToFahrenheit(temperature);
            case F2C -> fahrenheitToCelsius(temperature);
        };
    }
}
