package ch09_lambdas_streams.intro;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class ExternalInternalIterationExample
{
    public static void main(String[] args)
    {
        final List<String> names = Arrays.asList("Andi", "Mike", "Ralph", "Stefan");

        // $\mbox{\bfseries Klassische Variante mit Iterator ... }$
        final Iterator<String> it = names.iterator();
        while (it.hasNext())
        {
            System.out.println(it.next());
        }

        // $\mbox{\bfseries ... oder alternativ mit indiziertem Zugriff }$
        for (int i = 0; i < names.size(); i++)
        {
            System.out.println(names.get(i));
        }

        // $\mbox{\bfseries JDK-5-Schreibweise mit \string"for-each\string" }$
        for (final String name : names)
        {
            System.out.println(name);
        }

        // $\mbox{\bfseries Interne Iteration in zwei Varianten }$
        names.forEach(name -> System.out.println(name));
        names.forEach(System.out::println);
    }
}
