package ch09_lambdas_streams.intro;

import java.util.List;
import java.util.stream.Stream;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class FilterExample
{
    public static void main(String[] args)
    {
        var persons = List.of(new Person("John", 44, "Zürich"), 
                              new Person("Janne", 41, "Kiel", Gender.FEMALE),
                              new Person("James", 5, "Hamburg"));

        Stream<Person> adults = persons.stream().filter(Person::isAdult);
        adults.forEach(System.out::println);

        Stream<Person> allAdultMichas = persons.stream().filter(Person::isAdult)
                        .filter(person -> person.name().equals("John")).filter(john -> john.livesIn("Zürich"));
        allAdultMichas.forEach(System.out::println);
    }
}
