package ch10_fileio.praxsiexamples;

import java.io.File;
import java.io.IOException;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class DirectoryTree
{
    public static void main(String[] args) throws IOException
    {
        File currentDir = new File("."); // current directory

        printDirectory(currentDir, 0);
    }

    
    static void printDirectory(File currentDir, int level)
    {
        final File[] files = currentDir.listFiles();
        for (File file : files)
        {
            System.out.print("    ".repeat(level));
            System.out.println(file.getName());
            if (file.isDirectory())
            {
                printDirectory(file, level + 1);
            }
        }
    }
}