package ch10_fileio.praxsiexamples;

import java.io.File;
import java.io.IOException;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class DirectoryTree2
{
    public static void main(String[] args) throws IOException
    {
        File currentDir = new File("."); // current directory

        System.out.println(currentDir.getName());
        printDirectory(currentDir, 0);
    }

    static void printDirectory(File currentDir, int level)
    {
        final File[] files = currentDir.listFiles();

        for (int i = 0; i < files.length; i++)
        {
            File file = files[i];
            boolean isLast = i == files.length - 1;

            System.out.print("    ".repeat(level));
            if (isLast)
                System.out.print("\\-- ");
            else
                System.out.print("|-- ");

            System.out.println(file.getName());
            if (file.isDirectory())
            {
                printDirectory(file, level + 1);
            }
        }
    }
}