package ch10_fileio.praxsiexamples;

import java.io.File;
import java.io.IOException;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2020 Michael Inden
 */
public class DirectoryTree3
{
    public static void main(String[] args) throws IOException
    {
        printDirectory(new File("."), "");
    }

    static void printDirectory(File currentDir, String indent)
    {
        final File[] files = currentDir.listFiles();
    
        for (int i = 0; i < files.length; i++)
        {
            File file = files[i];
            boolean isLast = i == files.length - 1;
    
            System.out.print(indent);
            
            if (isLast)
                System.out.print("\\-- ");
            else
                System.out.print("|-- ");
    
            System.out.println(file.getName());
            if (file.isDirectory())
            {
                String newIndent = isLast ? "    " : "|   ";
                printDirectory(file, indent + newIndent);
            }
        }
    }
}