package ch10_fileio.praxsiexamples;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.stream.Stream;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class DirectoryTreeWithPath
{
    public static void main(String[] args) throws IOException
    {
        Path currentDir = Path.of("."); // current directory

        printDirectory(currentDir, 0);
    }

    static void printDirectory(Path currentDir, int level) throws IOException
    {
        try (Stream<Path> dirContent = Files.list(currentDir))
        {        
            for (Path path : dirContent.toList())
            {
                System.out.print("    ".repeat(level));
                System.out.println(path.getFileName());
                if (Files.isDirectory(path))
                {
                    printDirectory(path, level + 1);
                }
            }
        }
    }
}