package ch10_fileio.praxsiexamples;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.List;
import java.util.stream.Stream;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class DirectoryTreeWithPath2
{
    public static void main(String[] args) throws IOException
    {
        printDirectory(Path.of("."), 0);
    }

    static void printDirectory(Path currentDir, int level) throws IOException
    {
        try (Stream<Path> dirContent = Files.list(currentDir))
        {        
            List<Path> paths = dirContent.toList();
                
            for (int i = 0; i < paths.size(); i++)
            {
                Path path = paths.get(i);
                boolean isLast = i == paths.size() - 1;

                System.out.print("    ".repeat(level));
                if (isLast)
                    System.out.print("\\-- ");
                else
                    System.out.print("|-- ");

                System.out.println(path.getFileName());
                if (Files.isDirectory(path))
                {
                    printDirectory(path, level + 1);
                }
            }
        }
    }
}