package ch12_date_and_time.solutions;

import java.time.DayOfWeek;
import java.time.LocalDate;
import java.time.temporal.TemporalAdjusters;

/**
 * Beispielprogramm für das Buch "Java Challenge" / "Einfach Java"
 *
 * @author Michael Inden
 *
 * Copyright 2020/2021 by Michael Inden
 */
public class Ex01_WeekDays
{
    private Ex01_WeekDays()
    {
    }

    public static void main(final String[] args)
    {
        final LocalDate christmasEve = LocalDate.of(2019, 12, 24);
        System.out.println("24. Dez. 2019 = " + christmasEve.getDayOfWeek());
        System.out.println("24. Dez. 2019 = " + DayOfWeek.from(christmasEve));
        printWeekDay(christmasEve);
        
        final var decemberFirst = christmasEve.with(TemporalAdjusters.firstDayOfMonth());
        System.out.println("01. Dez. 2019 = " + decemberFirst.getDayOfWeek());

        final var decemberLast = christmasEve.with(TemporalAdjusters.lastDayOfMonth());
        System.out.println("31. Dez. 2019 = " + decemberLast.getDayOfWeek());
    }

    static void printWeekDay(LocalDate date)
    {
        System.out.println(date + " is a " + date.getDayOfWeek());
    }
}
