package ch13_tic_tac_toe;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 * <p>
 * (C) 2021 Michael Inden
 */
public class TicTacToe
{
    private char[][] board             = initializeBoard();

    private char     currentPlayerMark = 'X';

    public TicTacToe()
    {
    }

    public char[][] initializeBoard()
    {
        char[][] board = new char[3][3];
        for (int row = 0; row < 3; row++)
        {
            for (int col = 0; col < 3; col++)
            {
                board[row][col] = '-';
            }
        }
        return board;
    }

    public void printBoard()
    {
        System.out.println("-------------");

        for (int row = 0; row < 3; row++)
        {
            System.out.print("| ");
            for (int col = 0; col < 3; col++)
            {
                System.out.print(board[row][col] + " | ");
            }
            System.out.println();
            System.out.println("-------------");
        }
    }

    public boolean placeMark(int row, int col)
    {
        if (board[row][col] == '-')
        {
            board[row][col] = currentPlayerMark;
            return true;
        }

        return false;
    }

    public boolean isBoardFull()
    {
        for (int i = 0; i < 3; i++)
        {
            for (int j = 0; j < 3; j++)
            {
                if (board[i][j] == '-')
                {
                    return false;
                }
            }
        }

        return true;
    }

    public boolean checkForWin()
    {
        return (checkRowsForWin() || checkColumnsForWin() || checkDiagonalsForWin());
    }

    private boolean checkRowsForWin()
    {
        for (int col = 0; col < 3; col++)
        {
            if (checkAllSame(board[col][0], board[col][1], board[col][2]))
            {
                return true;
            }
        }
        return false;
    }

    private boolean checkColumnsForWin()
    {
        for (int row = 0; row < 3; row++)
        {
            if (checkAllSame(board[0][row], board[1][row], board[2][row]))
            {
                return true;
            }
        }
        return false;
    }

    private boolean checkDiagonalsForWin()
    {
        return ((checkAllSame(board[0][0], board[1][1], board[2][2]))
                || (checkAllSame(board[0][2], board[1][1], board[2][0])));
    }

    private boolean checkAllSame(char c1, char c2, char c3)
    {
        return ((c1 != '-') && (c1 == c2) && (c2 == c3));
    }

    public void changePlayer()
    {
        if (currentPlayerMark == 'X')
        {
            currentPlayerMark = 'O';
        }
        else
        {
            currentPlayerMark = 'X';
        }
    }

    public static void main(String[] args)
    {
        TicTacToe game = new TicTacToe();

        game.placeMark(0, 2);
        game.changePlayer();
        game.placeMark(1, 1);
        game.changePlayer();

        game.printBoard();

        // ... das Spiel geht weiter ...
        game.placeMark(2, 0);
        game.changePlayer();
        game.placeMark(1, 2);
        game.changePlayer();
        game.printBoard();

        // Haben wir einen Sieger?
        if (game.checkForWin())
        {
            System.out.println("We have a winner! Congrats!");
            System.exit(0);
        }
        else if (game.isBoardFull())
        {
            System.out.println("Appears we have a draw!");
            System.exit(0);
        }
    }
}
