package ch15_wordraetsel;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class HtmlCreator
{
    private final Model model;
    
    public HtmlCreator(final Model model)
    {
        this.model = model;
    }
    
    public String exportAsHtml()
    {
        String result = """
                        <html>
                            <head>
                                 <style>
                                    td {
                                        font-size: 18pt;
                                    }
                                </style>
                            </head>
                        <body>
                        """;

        result += createTable();
        result += createWordList();

        result += """
                            </body>
                        </html>
                        """;

        return result;
    }

    private String createWordList()
    {
        String result = "<ul>";
        
        for (String word : model.getWordsToSearch())
            result += "<li>" + word + "</li>";

        result += "</ul>";
        
        return result;
    }

    private String createTable()
    {
        String result = "<table border = '3' style='text-align:center'";
        
        for (int y = 0; y < model.getBoardHeight(); y++)
        {
            result += "<tr>";
            for (int x = 0; x < model.getBoardWidth(); x++)
            {
                result += "<td>" + model.getAt(x, y) + "</td>";
            }
            result += "</tr>";
        }
        result += "</table>";
        
        return result;
    }
}
