package ch15_wordraetsel;

import java.awt.Desktop;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class View
{
    private final Model model;
    
    public View(final Model model)
    {
        this.model = model;
    }
    
    public void displayOnConsole()
    {
        for (int y = 0; y < model.getBoardHeight(); y++)
        {
            for (int x = 0; x < model.getBoardWidth(); x++)
            {
                System.out.print(model.getAt(x, y));
            }
            System.out.println();
        }
        
        System.out.println("Search for: " + model.getWordsToSearch());
    }
    
    public void displayInBrowser() throws IOException
    {
        Path htmlFile = createHtml();        
        Desktop.getDesktop().browse(htmlFile.toUri());            
    }
    
    
    private Path createHtml() throws IOException
    {
        String html = new HtmlCreator(model).exportAsHtml();
        
        Path htmlFile = Files.createTempFile("words", ".html");
        Files.writeString(htmlFile, html);
        
        return htmlFile;
    }
}
