package ch15_wordraetsel;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.List;

/**
 * Beispielprogramm für das Buch "Einfach Java"
 *
 * (C) 2021 Michael Inden
 */
public class WordImporter
{
    public static List<String> importWords() throws IOException
    {
        final Path wordsFile = Path.of("src/main/java/ch15_wordraetsel/words.txt");
        final String content = Files.readString(wordsFile);

        return content.lines().map(String::trim).
                               map(String::toUpperCase).
                               filter(WordImporter::isIgnorable).
                               toList();
    }

    private static boolean isIgnorable(final String word)
    {
        return !word.isEmpty() && !isComment(word);
    }

    private static boolean isComment(final String word)
    {
        return word.startsWith("#") || word.startsWith("//");
    }
}